use crate::{
    auth::{get_user_from_header, Permissions},
    model::User,
    AppState,
};
use axum::{
    extract::State,
    http::{HeaderMap, StatusCode},
    routing::get,
    Json, Router,
};

pub mod auth;
pub mod member;
pub mod user;

pub fn routes() -> Router<AppState> {
    Router::new()
        .route("/", get(root))
        // .route("/member/:id", get())
        .merge(member::routes())
        .merge(auth::routes())
}

async fn root(
    State(state): State<AppState>,
    // permissions: Permissions<'_>,
    headers: HeaderMap,
) -> Result<Json<User>, crate::Error> {
    let user = get_user_from_header(&state.pool, &headers).await?;

    Ok(Json(user))
}
